package xyz.zhouxy.plusone.domain;

import java.io.Serializable;
import java.util.Optional;

/**
 * Repository 基础接口
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 * @see AggregateRoot
 */
public interface IRepository<T extends AggregateRoot<ID>, ID extends Serializable> {

    Optional<T> find(ID id);

    T save(T entity);

    void delete(T entity);

    boolean exists(ID id);

}
