package xyz.zhouxy.plusone.sms;

import java.util.Map;

import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * SMS 相关参数
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@ConfigurationProperties("plusone.sms")
public class SmsProperties {
    private String region;
    private SmsCredentialProperties credential;
    private SmsClientProperties client;
    private String appId;
    private Map<String, String> templates;

    public String getRegion() {
        return region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public SmsCredentialProperties getCredential() {
        return credential;
    }

    public void setCredential(SmsCredentialProperties credential) {
        this.credential = credential;
    }

    public SmsClientProperties getClient() {
        return client;
    }

    public void setClient(SmsClientProperties client) {
        this.client = client;
    }

    public String getAppId() {
        return appId;
    }

    public void setAppId(String appId) {
        this.appId = appId;
    }

    public Map<String, String> getTemplates() {
        return templates;
    }

    public void setTemplates(Map<String, String> templates) {
        this.templates = templates;
    }

    public static class SmsCredentialProperties {
        private String secretId;
        private String secretKey;

        public String getSecretId() {
            return secretId;
        }

        public void setSecretId(String secretId) {
            this.secretId = secretId;
        }

        public String getSecretKey() {
            return secretKey;
        }

        public void setSecretKey(String secretKey) {
            this.secretKey = secretKey;
        }
    }

    public static class SmsClientProperties {
        private String signMethod;
        private SmsHttpProperties http;

        public String getSignMethod() {
            return signMethod;
        }

        public void setSignMethod(String signMethod) {
            this.signMethod = signMethod;
        }

        public SmsHttpProperties getHttp() {
            return http;
        }

        public void setHttp(SmsHttpProperties http) {
            this.http = http;
        }
    }

    public static class SmsHttpProperties {
        private SmsProxyProperties proxy;
        private String reqMethod;
        private Integer connTimeout;

        public SmsProxyProperties getProxy() {
            return proxy;
        }

        public void setProxy(SmsProxyProperties proxy) {
            this.proxy = proxy;
        }

        public String getReqMethod() {
            return reqMethod;
        }

        public void setReqMethod(String reqMethod) {
            this.reqMethod = reqMethod;
        }

        public Integer getConnTimeout() {
            return connTimeout;
        }

        public void setConnTimeout(Integer connTimeout) {
            this.connTimeout = connTimeout;
        }
    }

    public static class SmsProxyProperties {
        private String host;
        private Integer port;

        public String getHost() {
            return host;
        }

        public void setHost(String host) {
            this.host = host;
        }

        public Integer getPort() {
            return port;
        }

        public void setPort(Integer port) {
            this.port = port;
        }
    }

}
