package xyz.zhouxy.plusone.system.application.common.exception;

import xyz.zhouxy.plusone.exception.BizException;

/**
 * 不支持的 Principal 类型出现时抛出的异常
 *
 * @author <a href="https://zhouxy.xyz:3000/ZhouXY108">ZhouXY</a>
 */
public class UnsupportedPrincipalTypeException extends BizException {

    private static final long serialVersionUID = 5207757290868470762L;

    public static final int ERR_CODE = 4040201;
    private static final String DEFAULT_ERROR_MSG = "不支持的 PrincipalType";

    public UnsupportedPrincipalTypeException() {
        super(ERR_CODE, DEFAULT_ERROR_MSG);
    }

    public UnsupportedPrincipalTypeException(String msg) {
        super(ERR_CODE, msg);
    }

    public UnsupportedPrincipalTypeException(Throwable cause) {
        super(ERR_CODE, cause);
    }

    public UnsupportedPrincipalTypeException(String msg, Throwable cause) {
        super(ERR_CODE, msg, cause);
    }
}
